apiready = function() {
  //获取页面传递信息
  const pageParam = api.pageParam;
  const token = pageParam.token;
  //获取nodeTopic
  const selectHosData = JSON.parse($api.getStorage('select-hos-data'));
  const nodeTopic = selectHosData.nodeTopic;
  const hospitalName = selectHosData.hospitalName;
   //win页面类
   class PageWin {
       constructor() {
           this.bindEvent(); //绑定页面事件
       }
       bindEvent() { //绑定页面事件
           $('.aui-pull-left').on('click', function() {
             api.closeToWin({
                 name: 'selectPatient-win',
             });
           });
           api.addEventListener({
              name: 'keyback'
           }, function(ret, err){    
             api.closeToWin({
                 name: 'selectPatient-win',
             });
           });
       }
       init() {
           api.openFrame({
               name: 'registration-day-registrationList-frame',
               url: '../frame/registrationListFrame.html',
               rect: {
                   x: 0,
                   y: $api.dom('header').offsetHeight,
                   w: 'auto',
                   h: 'auto'
               },
               bounces: true,
               pageParam: pageParam,
               reload: true,
               bgColor: '#f5f5f5'
           });
       }
   }
   //frame页面类
   class pageFrame {
       constructor() {}
       init() {
           this.bindEvent(); //绑定页面事件
           this.queryData(); //查询当日挂号记录
       }
       bindEvent() { //绑定页面事件
         //选择支付订单
         $('.registration_list').on('click','.item .barcode_icon',function(event){
             var extendedField = $(this).parents('.item').find('.extendedField .val').text();
             $("#barcode_box").JsBarcode(extendedField);
             $('#mask').show();
         });
         $('#mask').on('click',function(){
            $('#mask').hide();
         })
       }
       queryData() { //获取数据
         let objData = {
            nodeTopic:nodeTopic,
            kh:pageParam.select_idcard,
            klx:4,
         }
         let headerInfo = {
           Authorization:token,
           APIType:1
         }
         $.globalGet(EHZAPI_BASEURL_DEP, `/api/register/today/queryRegRecord?nodeTopic=${objData.nodeTopic}&kh=${objData.kh}&klx=${objData.klx}`, headerInfo, (res)=> {
            //console.log(JSON.stringify(res.REG))
            this.renderData(res.REG)
         }, (error)=> {
            $('.default-page').show();
         })
       }
       renderData(dataList) { //渲染页面数据
         if(dataList != undefined && dataList.length > 0){
             $.each(dataList,function(i,item){
               let str = '';
               str+=`<div class="item">`
               str+=`<p class="appTitle">
               <span>${item.REGTIME}</span>
               <span>${item.MJZH}</span>
               <span>${item.WAITSTATE}</span>
               </p>`
                str+=`<p class="hosName"><span>医院</span>`
                str+='<span class="val">'+hospitalName+'</span>'
                str+=`</p>`
                if(item.DOCTORNAME){
                  str+=`<p class="departName">
                    <span>科室/医生</span>
                    <span class="val">${item.DEPARTMENTNAME}/${item.DOCTORNAME}/${item.REGTYPE}</span>
                  </p>`
                }else{
                  str+=`<p class="departName">
                    <span>科室/医生</span>
                    <span class="val">${item.DEPARTMENTNAME}/${item.REGTYPE}</span>
                  </p>`
                }
                str+=`<p class="patient">
                  <span>就诊人</span>
                  <span class="val">${item.PATIENTNAME}</span>
                </p>
                <p class="extendedField">
                  <span>门诊号</span>
                  <span class="val">${item.REGFLOW}</span>
                </p>
                <p class="price" style="display:none;">
                  <span>预约费</span>
                  <span class="val">12.00元</span>
                </p>`
                if(item.REGFLOW){
                  str+=`<div class="barcode_icon"></div>`
                }
                str+=`</div>`
               $('.registration_list').append(str)
             })
         }else{
           $('.default-page').show();
         }
       }
   }
   if ($('body').attr('page-type') == 'win') {
       new PageWin().init(); //win页面初始化
   } else {
       new pageFrame().init(); //frame页面初始化
   }
 };
