apiready = function() {

   //获取页面传递信息
   const pageParam = api.pageParam;
   const token = pageParam.token;
   //获取nodeTopic
   const selectHosData = JSON.parse($api.getStorage('select-hos-data'))
   console.log(JSON.stringify(selectHosData));
   const nodeTopic = selectHosData.nodeTopic;
   const hospitalName = selectHosData.hospitalName;
   //win页面类
   class PageWin {
       constructor() {
           this.bindEvent(); //绑定页面事件
           this.name = '';
       }
       bindEvent() { //绑定页面事件
         let that = this;
           $('.aui-pull-left').on('click', function() {
               api.closeWin();
           });
           $('.search_box .input_box input').on('input',function(){
              let name = $(this).val();
              that.goFrame(name);
           })
           $('.btn_box').on('click',function(){
              let name = $('.search_box .input_box input').val();
              that.goFrame(name);
           })
       }
       init() {
           $('.hospitalName').text(hospitalName);
           this.goFrame(this.name);
       }
       goFrame(name){
         console.log(name)
         let data = { ...pageParam};
         data.selectDepartmentName = name
         api.openFrame({
             name: 'registration-day-selectDepartment-frame',
             url: '../frame/selectDepartmentFrame.html',
             rect: {
                 x: 0,
                 y: $api.dom('header').offsetHeight+$api.dom('.hospitalBox').offsetHeight+$api.dom('.search_box').offsetHeight+parseFloat(this.getStyle($api.dom('.search_box'), 'marginTop'))+parseFloat(this.getStyle($api.dom('.search_box'), 'marginBottom')),
                 w: 'auto',
                 h: 'auto'
             },
             bounces: true,
             pageParam:data,
             reload: true,
             bgColor: '#f5f5f5'
         });
       }
       getStyle(obj, attr) {
            if (obj.currentStyle) {
                return obj.currentStyle[attr];
            } else {
                return document.defaultView.getComputedStyle(obj, null)[attr];
            }
        }
   }
   //frame页面类
   class pageFrame {
       constructor() {}
       init() {
           this.bindEvent(); //绑定页面事件
           this.getDataList() //获取科室列表
       }
       bindEvent() { //绑定页面事件
           //取消
           $('.department_list').on('click','.item',function(){
              let paramData = { ...pageParam};
              paramData.departmentId = $(this).attr('departmentId');
              paramData.departmentName = $(this).attr('departmentName');
              api.openWin({
                  name: 'registration-day-selectDoctor-win',
                  url: '../win/selectDoctor.html',
                  pageParam: paramData
              });
           })
       }
       getDataList(){
         let name = pageParam.selectDepartmentName;
         let headerInfo = {
           Authorization:token,
           APIType:1
         }
         $.globalGet(EHZAPI_BASEURL_DEP, `/api/register/today/queryLevelOneDepartmentList?nodeTopic=${nodeTopic}&name=${name}`, headerInfo, (res)=> {
            // console.log(JSON.stringify(res))
            this.renderData(res)
         }, (error)=> {
             allError(error)
         })
       }
       renderData(dataList){
          //console.log(JSON.stringify(dataList))
          if(dataList != undefined && dataList.length > 0){
              $.each(dataList,function(i,item){
                let str=`<li class="item" departmentId ="${item.DEPARTMENTID}" departmentName = "${item.DEPARTMENTNAME}">
                   <div class="departName">${item.DEPARTMENTNAME}</div>
                   <div class="details_icon"><span class="aui-iconfont aui-icon-right right_icon"></span></div>
                </li>`
                $('.department_list .item_box').append(str)
              })
          }else{
            $('.default-page').show();
          }
       }
   }
   if ($('body').attr('page-type') == 'win') {
       new PageWin().init(); //win页面初始化
   } else {
       new pageFrame().init(); //frame页面初始化
   }
 };
